<?php
/*
 * Scaffoldr - a PHP scaffold (skeletal) generator for MySQL-Databases.
 * Just provide the connection credentials and this script will generate the CRUD pages for you in
 * a second.
 * URL: http://developer.gauner.org/scaffoldr/
 * Author: Dominik Schulz <lkml_AT_ds_DOT_gauner_DOT_org>
 * License: GPLv2
 * Version: 2.0-05
 * TODO: composite keys: dito
 */

require_once("../lib/_class.dba.inc.php");

// BEGIN OF FUNCTION DEFINITION

/**
 * write_file
 * @arg $filename (string) - The Filename to write to
 * @arg $string (string) - The String to write in the file
 * @retruns true or false, wheter the operation was successfull or not
 */
function write_file($filename, $string) {
	if(!is_file($filename) || is_writeable($filename)) {
		if(!$handle = @fopen($filename, "w")) {
			//echo("Can't open ".$filename."<br> ");
			return false;
		}
		if(!fwrite($handle,$string)) {
			//echo("Can't write to ".$filename."<br> ");
			return false;
		}
		@fclose($handle);
	} else {
		//echo("File already exists and is not writeable");
		return false;
	}
	@chmod($filename, 0775); // Set writing permissions for the group on the files
	@chmod(dirname($filename), 0775);  // Set writing permissions for the group on the directory
	return true;
}

/**
 * Create a HTML Form Input element for the given data type.
 *
 * @param unknown_type $a_type
 * @param unknown_type $a_name
 * @return unknown
 */
function get_html_input($a_name, $type, $size) {
	// code block for date
	$tmpl_date = '<?php $'.$a_name.'_year= substr($row[\''.$a_name.'\'],0,4); $row[\''.$a_name.'\']=substr($row[\''.$a_name.'\'],4); ?>';
	$tmpl_date .= '<?php $'.$a_name.'_month= substr($row[\''.$a_name.'\'],1,2); $row[\''.$a_name.'\']=substr($row[\''.$a_name.'\'],3); ?>';
	$tmpl_date .= '<?php $'.$a_name.'_day= substr($row[\''.$a_name.'\'],1,2); $row[\''.$a_name.'\']=substr($row[\''.$a_name.'\'],4); ?>';
	$tmpl_date .= '<select name="'.$a_name.'_year">'."\n";
	for($i = 1901; $i < 2156; $i++) {
		$tmpl_date .= '<option<?php if($'.$a_name.'_year=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
	}
	$tmpl_date .= "\n</select>-";
	$tmpl_date .= '<select name="'.$a_name.'_month">'."\n";
	for($i = 1; $i < 13; $i++) {
		$tmpl_date .= '<option<?php if($'.$a_name.'_month=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
	}
	$tmpl_date .= "\n</select>-";
	$tmpl_date .= '<select name="'.$a_name.'_day">'."\n";
	for($i = 1; $i < 32; $i++) {
		$tmpl_date .= '<option<?php if($'.$a_name.'_day=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
	}
	$tmpl_date .= "\n</select>\n";
	// code block for time
	$tmpl_time = '<?php $'.$a_name.'_hour= substr($row[\''.$a_name.'\'],0,2); $row[\''.$a_name.'\']=substr($row[\''.$a_name.'\'],3); ?>';
	$tmpl_time .= '<?php $'.$a_name.'_minute= substr($row[\''.$a_name.'\'],0,2); $row[\''.$a_name.'\']=substr($row[\''.$a_name.'\'],2); ?>';
	$tmpl_time .= '<?php $'.$a_name.'_second= substr($row[\''.$a_name.'\'],1,2); $row[\''.$a_name.'\']=substr($row[\''.$a_name.'\'],2); ?>';
	$tmpl_time .= '<select name="'.$a_name.'_hour">'."\n";
	for($i = 1; $i < 25; $i++) {
		$tmpl_time .= '<option<?php if($'.$a_name.'_hour=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
	}
	$tmpl_time .= "\n</select>:";
	$tmpl_time .= '<select name="'.$a_name.'_minute">'."\n";
	for($i = 1; $i < 61; $i++) {
		$tmpl_time .= '<option<?php if($'.$a_name.'_minute=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
	}
	$tmpl_time .= "\n</select>:";
	$tmpl_time .= '<select name="'.$a_name.'_second">'."\n";
	for($i = 1; $i < 61; $i++) {
		$tmpl_time .= '<option<?php if($'.$a_name.'_second=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
	}
	$tmpl_time .= "\n</select>\n";
	switch($type) {
		case float:
		case double:
		case decimal:
		case tinyint:
		case bigint:
		case smallint:
		case mediumint:
		case int:
		case varchar:
			$retval = '<input type="text" size="50" maxlength="'.$size.'" value="<?= $row[\''.$a_name.'\'] ?>" name="'.$a_name.'">'."\n";
			break;
		case datetime:
		case timestamp:
			$retval = $tmpl_date;
		case time:
			$retval .= $tmpl_time;
			break;
		case year:
			$retval = '<select name="'.$a_name.'">'."\n";
			for($i = 1901; $i < 2156; $i++) {
				$retval .= '<option<?php if($row[\''.$a_name.'\']=="'.$i.'") echo(" selected"); ?>>'.$i.'</option>'."\n";
			}
			$retval .= "\n</select>\n";
			break;
		case date:
			$retval = $tmpl_date;
			break;
		case char:
			$retval = '<input type="text" size="1" value="<?= $row[\''.$a_name.'\'] ?>" name="'.$a_name.'">'."\n";
			break;
		case tinytext:
		case longtext:
		case mediumtext:
		case text:
			$retval = '<textarea name="'.$a_name.'" cols="80" rows="24"><?= $row[\''.$a_name.'\'] ?></textarea>'."\n";
			break;
		case boolean:
		case bool:
			$retval = '<select name="'.$a_name.'">'."\n".'<option value="true" <?php if($row[\''.$a_name.'\']=="true") echo("selected"); ?>>True</option>'."\n";
			$retval .= '<option value="false" <?php if($row[\''.$a_name.'\']=="false") echo("selected"); ?>>False</option>'."\n</select>\n";
			break;
		case enum:
		case set:
			$options = explode(",", $size);
			$retval = '<select name="'.$a_name.'">'."\n";
			for($i=0;$i<count($options);$i++) {
				$options[$i] = substr($options[$i], 1, strlen($options[$i])-2); // remove '
				$retval .= "<option <?php if(\$row['".$a_name."']=='".$options[$i]."') echo(\"selected\"); ?>>".$options[$i]."</option>\n";
			}
			$retval .= '</select>'."\n";
			break;
	}
	return $retval;
}

function format_field_name($field_name) {
	$retval = str_replace("_", " ", $field_name);
	return $retval;
}

/**
 * Return the first found primary key from the fields array.
 * If there is no PK, the first key will be returned.
 *
 * @param unknown_type $fields
 */
function get_first_pk($fields) {
	$fallback = $fields[0]['name'];
	for($i = 0; $i < sizeof($fields); $i++) {
		if($fields[$i]['is_primary']) {
			return $fields[$i]['name'];
		}
	}
	return $fallback;
}
// END OF FUNCTION DEFINITION

// Set default values
$php_head_extra = "";
$lib_path = "../";
$config_path = "../";
$http_proto = "http";
$application_title = "Scaffoldr";
$css_path = "../../style.css";
$html_header_extra = "";
$body_header_extra = "";
$body_footer_extra  = "";
$php_order_limit = "25";
$db_user = "";
$db_pass = "";
$db_db = "";
$db_host = "localhost";
$e = "";
$output_dir_index = "<html><head><title>Scaffoldr Directory Index</title><body><p>";

// Check input values
if(IsSet($_REQUEST['db_user']) && IsSet($_REQUEST['db_pass']) && IsSet($_REQUEST['db_db']) && IsSet($_REQUEST['db_host'])
&& IsSet($_REQUEST['php_head_extra']) && IsSet($_REQUEST['lib_path']) && IsSet($_REQUEST['config_path'])
&& IsSet($_REQUEST['http_protocol']) && IsSet($_REQUEST['application_title'])
&& IsSet($_REQUEST['css_path']) && IsSet($_REQUEST['html_header_extra'])
&& IsSet($_REQUEST['body_header_extra']) && IsSet($_REQUEST['body_footer_extra'])
&& IsSet($_REQUEST['php_order_limit'])) {

	$db_user = $_REQUEST['db_user'];
	$db_pass = $_REQUEST['db_pass'];
	$db_db = $_REQUEST['db_db'];
	$db_host = $_REQUEST['db_host'];
	// setup db connection
	$dba = new dba;
	$dba->appname = "Scaffoldr";
	$dba->database = $db_db;
	$dba->server = $db_host;
	$dba->user = $db_user;
	$dba->password = $db_pass;
	$dba->connect();

	$output_dir = "output/";
	$e .= "Running on Database ".$_REQUEST['db_db']." ...\n";
	$output_dir_index .= "<h2>Scaffolds for Database ".$_REQUEST['db_db']." on host ".$_REQUEST['db_host']."</h2>";
	$output_dir_index .= "Created on ".date("d.m.Y h:i:s")."\n<ul>";
	// common settings
	$php_head_extra = $_REQUEST['php_head_extra'];
	//$e .= "PHP_HEAD_EXTRA:\n".$php_head_extra."\n";
	$lib_path = $_REQUEST['lib_path'];
	//$e .= "LIB_PATH: ".$lib_path."\n";
	$config_path = $_REQUEST['config_path'];
	//$e .= "CONFIG_PATH: ".$config_path."\n";
	$http_proto = $_REQUEST['http_protocol'];
	if($http_proto != "http" && $http_proto != "https") {
		$http_proto = '".'.$http_proto.'."';
	}
	if(stripos($http_proto,"\\") > 0) {
		$http_proto = str_replace("\\","",$http_proto);
	}
	//$e .= "Http-Proto: ".$http_proto."\n";
	//$e .= "HTTP_PROTOCOL: ".$http_proto."\n";
	$application_title = $_REQUEST['application_title'];
	//$e .= "APPLICATION_TITLE: ".$application_title."\n";
	$css_path = $_REQUEST['css_path'];
	//$e .= "CSS_PATH: ".$css_path."\n";
	$html_header_extra = $_REQUEST['html_header_extra'];
	//$e .= "HTML_HEADER_EXTRA:\n".$html_header_extra."\n";
	$body_header_extra = $_REQUEST['body_header_extra'];
	//$e .= "BODY_HEADER_EXTRA:\n".$body_header_extra."\n";
	$body_footer_extra = $_REQUEST['body_footer_extra'];
	//$e .= "BODY_FOOTER_EXTRA:\n".$body_footer_extra."\n";
	$php_order_limit = $_REQUEST['php_order_limit'];
	if(stripos($php_order_limit,"\\") > 0) {
		$php_order_limit = str_replace("\\","",$php_order_limit);
	}
	//$e .= "List-Limit: ".$php_order_limit."\n";
	//$e .= "PHP_ORDER_LIMIT: ".$php_order_limit."\n";

	// get tables to process
	$query = "SHOW TABLES";
	$results = $dba->query($query);
	// process each table
	while($row = $dba->fetch_array($results)) {
		$scaffold_name = $row[0];
		$e .= "-> Processing: ".$scaffold_name." ... ";
		$output_dir_index .= "<li><a href=\"".$scaffold_name."\">".$scaffold_name."</a></li>";
		// create dir for scaffolding
		if(!is_dir($output_dir.$scaffold_name)) {
			@mkdir($output_dir.$scaffold_name);
		} else {
	 	//echo("Dir already created.\n ");
		}
		if(is_dir($output_dir.$scaffold_name)) {
			//$e .= "--> Created subdir: ".$scaffold_name."\n";
		} else {
			//$e .= "--> Error creating subdir: ".$scaffold_name."\n";
		}

		/**
		 * This array holds information about the fields in the table.
		 * Once the relevant information gained from describe table and the
		 * additional information about foreign key constraints from show create table.
		 * Field, Type, Description
		 * name, string
		 * type, string
		 * length, int
		 * is_primary, boolean,
		 * is_autoinc, boolean,
		 * is_foreign, boolean, is this a foreign key?
		 * fk_ref_table, string, foreign key: referenced table
		 * fk_ref_col, string, foreign key: referenced column
		 */
		$fields = array();
		// get table description
		$query = "DESCRIBE ".$scaffold_name;
		$inner_results = $dba->query($query);
		$i = 0;
		while($inner_row = $dba->fetch_array($inner_results)) {
			$fields[$i]['name'] = $inner_row[0];
			//$e .= "Name: ".$fields['name']."\n";
			// if the there is no opening bracket, the field has no given length
			if(strpos($inner_row[1],"(") === FALSE) {
				$fields[$i]['type'] = $inner_row[1];
				// length 0 has a special meaning.
				// since it is not possible that a field has the length 0,
				// this means that the length is unlimited.
				$fields[$i]['length'] = 0;
			} else {
				$tl = substr($inner_row[1],0,-1);
				//$e .= "TL: ".$tl."\n";
				$fields[$i]['type'] = strtok($tl,"(");
				$fields[$i]['length'] = strtok("(");
			}
			//$e .= "Type: ".$fields['type']."\n";
			//$e .= "Length: ".$fields['length']."\n";
			if($inner_row[3] == "PRI") {
				$fields[$i]['is_primary'] = TRUE;
			} else {
				$fields[$i]['is_primary'] = FALSE;
			}
			//$e .= "Primary: ".$fields['is_primary']."\n";
			if($inner_row[5] == "auto_increment") {
				$fields[$i]['is_autoinc'] = TRUE;
			} else {
				$fields[$i]['is_autoinc'] = FALSE;
			}
			//$e .= "Autoinc: ".$fields['is_autoinc']."\n";
			// fill the other fields
			$fields[$i]['is_foreign'] = FALSE;
			$fields[$i]['fk_ref_table'] = "";
			$fields[$i]['fk_ref_col'] = "";
			$i++;
		}
		$query = "SHOW CREATE TABLE ".$scaffold_name;
		$inner_row = $dba->query_first($query);
		//echo("<pre>");
		// Look if the result of the query contains FK definitions
		if(strpos($inner_row[1],"FOREIGN KEY") !== FALSE) {
			// find the foreign key definition
			$toks = split("\n",$inner_row[1]);
			for($i=0;$i < sizeof($toks);$i++) {
				$tok = $toks[$i];
				//echo("Tok: ".$tok."\n");
				$key = "";
				$ref_table = "";
				$ref_col = "";
				if(strpos($tok,"FOREIGN KEY") !== FALSE) {
					// found a foreign key definition in this line
					$line = trim($tok);
					//echo("Line: ".$line."\n");
					$tokis = split(" ",$line);
					for($j=0;$j < sizeof($tokis); $j++) {
						$toki = $tokis[$j];
						//echo("Toki: ".$toki."\n");
						if(strpos($toki,"KEY") !== FALSE) {
							//echo("Tokis[".($j+1)."]:".$tokis[$j+1]."\n");
							$key = substr(trim($tokis[$j+1]),2,-2);
							//echo("Key: ".$key."\n");
							//echo("Tokis[".($j+3)."]:".$tokis[$j+3]."\n");
							$ref_table = substr(trim($tokis[$j+3]),1,-1);
							//echo("Ref Table: ".$ref_table."\n");
							//echo("Tokis[".($j+4)."]:".$tokis[$j+4]."\n");
							$ref_col = substr(trim($tokis[$j+4]),2,-2);
							//echo("Ref Col: ".$ref_col."\n");
						}
					}
					// store the information in the field list
					for($j=0;$j<sizeof($fields);$j++) {
						if($fields[$j]['name']==$key) {
							$fields[$j]['is_foreign'] = TRUE;
							$fields[$j]['fk_ref_table'] = $ref_table;
							$fields[$j]['fk_ref_col'] = $ref_col;
							break;
						}
					}
				}
			}
		}
		//print_r($fields);
		//echo("</pre>");

		// ### create delete.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/delete.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$output = str_replace("PRIMARY_KEY",get_first_pk($fields),$output);
		$sqlquery = "SELECT * FROM ".$scaffold_name." WHERE ".get_first_pk($fields)."='\".\$_REQUEST['".get_first_pk($fields)."'].\"' LIMIT 1";
		$output = str_replace("SQL_QUERY",$sqlquery,$output);
		write_file($output_dir.$scaffold_name."/delete.php", $output);
		//$e .= "--> Created file: ".$scaffold_name."/delete.php.\n";

		// ### create edit.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/edit.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$sqlquery = "SELECT * FROM ".$scaffold_name." WHERE ".get_first_pk($fields)."='\".\$_REQUEST['".get_first_pk($fields)."'].\"' LIMIT 1";
		$output = str_replace("SQL_QUERY",$sqlquery,$output);
		$d_edit = "";
		for($i = 0; $i < sizeof($fields); $i++) {
			$field = $fields[$i];
			if($field['is_primary'] && $field['is_autoinc']) {
				$d_edit .= "<input type=\"hidden\" value=\"<?= \$row['".$field['name']."'] ?>\" name=\"id\">\n";
			} elseif($field['name'] == "created_at" || $field['name'] == "updated_at") {
				// omit, those fields are updated by the scaffold
			} elseif($field['is_foreign']) {
				$d_edit .= "<tr>\n";
				$d_edit .= "\t<td>".format_field_name($field['name'])."</td>\n";
				$d_edit .= "\t<td><select name=\"".$field['name']."\">\n";
				$d_edit .= "<?php\n\$query = \"SELECT * FROM ".$field['fk_ref_table']." ORDER BY ".$field['fk_ref_col']."\";\n";
				$d_edit .= "\$results = \$dba->query(\$query);\n";
				$d_edit .= "while(\$rowi = \$dba->fetch_array(\$results)) {\n";
				$d_edit .= "\tif(\$rowi['".$field['fk_ref_col']."'] == \$row['".$field['name']."']) {\n";
				$d_edit .= "\t\t\$selected = ' selected';\n";
				$d_edit .= "\t} else {\n";
				$d_edit .= "\t\t\$selected = '';\n";
				$d_edit .= "\t}\n";
				$d_edit .= "\techo(\"<option value='\".\$rowi['".$field['fk_ref_col']."'].\"'\$selected>\".\$rowi[0].\" \".\$rowi[1].\"</option>\");\n";
				$d_edit .= "}\n?>\n";
				$d_edit .= "</select>\n";
				$d_edit .= "<a href=\"../".$field['fk_ref_table']."/new.php\" target=\"_new\">New FK</a></td>\n";
				$d_edit .= "</tr>\n";
			} else {
				$d_edit .= "<tr>\n";
				$d_edit .= "\t<td>".format_field_name($field['name'])."</td>\n";
				$d_edit .= "\t<td>".get_html_input($field['name'],$field['type'],$field['size'])."</td>\n";
				$d_edit .= "</tr>\n";
			}
		}
		$output = str_replace("BODY_FORM_MAIN",$d_edit,$output);

		write_file($output_dir.$scaffold_name."/edit.php", $output);
		unset($d_edit);
		//echo("--> Created file: ".$scaffold_name."/edit.php.\n");


		// ### create index.php (redirecting to default action = list)
		$template = "";
		$output = "";
		$template = file_get_contents("templates/index.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		write_file($output_dir.$scaffold_name."/index.php", $output);
		//echo("--> Created file: ".$scaffold_name."/index.php.\n");

		// ### create insert.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/insert.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$sqlquery1 = 'INSERT INTO '.$scaffold_name.' (';
		$sqlquery2 = ") VALUES (";
		for($i=0;$i<sizeof($fields);$i++) {
			$field = $fields[$i];
			if($field['is_autoinc']) {
				// we don't want the primary key field to show up
				// it is generated by the db (auto_increment)
			} else {
				$sqlquery1 .= $field['name'].",";
				if($field['name'] == "created_at" || $field['name'] == "updated_at") {
					// these are auto-generated by the scaffold (us!)
					$sqlquery2 .= "'\".time().\"',";
				} else {
					$sqlquery2 .= "'\".mysql_real_escape_string(\$_REQUEST['".$field['name']."']).\"',";
				}
			}
		}
		// remove the last comma (,) from each query part
		$sqlquery = substr($sqlquery1,0,-1).substr($sqlquery2,0,-1).")";
		$output = str_replace("SQL_QUERY",$sqlquery,$output);
		write_file($output_dir.$scaffold_name."/insert.php", $output);
		unset($d_insert);
		//echo("--> Created file: ".$scaffold_name."/insert.php.\n");


		// ### create list.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/list.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);

		$my_list_limit = '$list_limit = '.$php_order_limit.";\n";
		$my_list_limit .= 'switch($_REQUEST[\'order\']) {'."\n";
		
		$d_list = "";
		$d_list2 = "";
		$is_first = true;
		for($i = 0; $i < sizeof($fields); $i++) {
			$field = $fields[$i];
			$a1 = "";
			$a2 = "";
			if($field['is_autoinc']) {
				// we don't want the primary key field to show up
				// it is generated by the db (auto_increment)
			} else {
				// build links which allow to toggle the sort order
				$d_list .= "<?php\nif(substr(\$order_link_arg_head,0,-4) == '".$field['name']."') {\n";
				$d_list .= "\t\$ola=\$order_link_arg_head;\n";
				$d_list .= "} else {\n";
				$d_list .= "\t\$ola='".$field['name']."';\n";
				$d_list .= "}\n?>\n";
				$d_list .= "<th><a href=\"list.php?order=<?= \$ola ?>\">".format_field_name($field['name'])."</a></th>\n";
				if($is_first) {
					$a1 = "<a href='edit.php?".get_first_pk($fields)."=\".\$row['".get_first_pk($fields)."'].\"'>";
					$a2 = "</a>";
					$is_first = false;
				}
				if(($field['name'] == "created_at") || ($field['name'] == "updated_at")) {
					$d_list2 .= "\t".'echo("\t<td>'.$a1.'".date("d.m.y H:i:s", $row[\''.$field['name'].'\'])."'.$a2.'</td>\n");'."\n";
				} else if($field['is_foreign']) {
					$d_list2 .= "\t\$queryi = \"SELECT * FROM ".$field['fk_ref_table']." WHERE ".$field['fk_ref_col']." = '\".\$row['".$field['name']."'].\"'\";\n";
					$d_list2 .= "\t\$rowi = \$dba->query_first(\$queryi);\n";
					$d_list2 .= "\t".'echo("\t<td>'.$a1.'".$rowi[0]."-".$rowi[1]." (".$row[\''.$field['name'].'\'].")'.$a2.'</td>\n");'."\n";
				} elseif($field['type'] == "text") {
					$d_list2 .= "\t".'echo("\t<td>'.$a1.'".substr(htmlentities($row[\''.$field['name'].'\']),0,80)." ...'.$a2.'</td>\n");'."\n";
				} else {
					$d_list2 .= "\t".'echo("\t<td>'.$a1.'".$row[\''.$field['name'].'\']."'.$a2.'</td>\n");'."\n";
				}
				$my_list_limit .= "\tcase '".$field['name']."':\n\tcase '".$field['name']."_asc':\n\t\t\$order_clause = \" ORDER BY ".$field['name']." ASC\";\n";
				$my_list_limit .= "\t\t\$order_link_arg_head = \"".$field['name']."_dsc\";\n";
				$my_list_limit .= "\t\t\$order_link_arg = \"".$field['name']."_asc\";\n\t\tbreak;\n";
				$my_list_limit .= "\tcase '".$field['name']."_dsc':\n\t\t\$order_clause = \" ORDER BY ".$field['name']." DESC\";\n";
				$my_list_limit .= "\t\t\$order_link_arg_head = \"".$field['name']."_asc\";\n";
				$my_list_limit .= "\t\t\$order_link_arg = \"".$field['name']."_dsc\";\n\t\tbreak;\n";
			}
		}
		$d_list .= "<th>CRUD</th></tr>\n";
		$d_list .= '<?php '."\n";
		$d_list .= 'while($row = $dba->fetch_array($results)) {'."\n".'echo("<tr>\n");'."\n";
		$d_list .= $d_list2;
		$d_list .= "\t".'echo("\t<td><a href=\"show.php?'.get_first_pk($fields).'=".$row[\''.get_first_pk($fields).'\']."\">Show</a> <a href=\"edit.php?'.get_first_pk($fields).'=".$row[\''.get_first_pk($fields).'\']."\">Edit</a> <a href=\"delete.php?'.get_first_pk($fields).'=".$row[\''.get_first_pk($fields).'\']."\">Delete</a></td>");'."\n";
		$d_list .= "\t".'echo("</tr> ");'."\n".'}'."\n".'?>'."\n".'</table>'."\n".'<br />'."\n";

		$my_list_limit .= "\tdefault:\n\t\t\$order_clause = \" ORDER BY ".get_first_pk($fields)."\";\n}\n";

		$output = str_replace("HTML_TABLE_TEXT",$d_list,$output);
		$output = str_replace("SQL_TABLE_NAME",$scaffold_name,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$my_list_limit,$output);
		write_file($output_dir.$scaffold_name."/list.php", $output);
		unset($d_list);
		//echo("--> Created file: ".$scaffold_name."/list.php.\n");


		// ### create new.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/new.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$d_new = "";
		for($i = 0; $i < sizeof($fields); $i++) {
			$field = $fields[$i];
			if($field['is_primary'] && $field['is_autoinc']) {
				$d_new .= "<input type=\"hidden\" value=\"<?= \$row['".$field['name']."'] ?>\" name=\"id\">\n";
			} elseif($field['name'] == "created_at" || $field['name'] == "updated_at") {
				// omit, those fields are updated by the scaffold
			} elseif($field['is_foreign']) {
				$d_new .= "<tr>\n";
				$d_new .= "\t<td>".format_field_name($field['name'])."</td>\n";
				$d_new .= "\t<td><select name=\"".$field['name']."\">\n";
				$d_new .= "<?php\n\$query = \"SELECT * FROM ".$field['fk_ref_table']." ORDER BY ".$field['fk_ref_col']."\";\n";
				$d_new .= "\$results = \$dba->query(\$query);\n";
				$d_new .= "while(\$row = \$dba->fetch_array(\$results)) {\n";
				$d_new .= "echo(\"<option value='\".\$row['".$field['fk_ref_col']."'].\"'>\".\$row[0].\" \".\$row[1].\"</option>\n\");\n";
				$d_new .= "}\n?>\n";
				$d_new .= "</select>\n";
				$d_new .= "<a href=\"../".$field['fk_ref_table']."/new.php\" target=\"_new\">New FK</a></td>\n";
				$d_new .= "</tr>\n";
			} else {
				$d_new .= "<tr>\n";
				$d_new .= "\t<td>".format_field_name($field['name'])."</td>\n";
				$d_new .= "\t<td>".get_html_input($field['name'],$field['type'],$field['size'])."</td>\n";
				$d_new .= "</tr>\n";
			}
		}
		$output = str_replace("BODY_FORM_MAIN",$d_new,$output);
		write_file($output_dir.$scaffold_name."/new.php", $output);
		unset($d_new);
		//echo("--> Created file: ".$scaffold_name."/new.php.\n");

		// ### create remove.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/remove.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$output = str_replace("PRIMARY_KEY",get_first_pk($fields),$output);
		$d_remove .= 'DELETE FROM '.$scaffold_name.' WHERE '.get_first_pk($fields).'=\'".$'.get_first_pk($fields).'."\' LIMIT 1';
		$output = str_replace("SQL_QUERY",$d_remove,$output);
		write_file($output_dir.$scaffold_name."/remove.php", $output);
		unset($d_remove);
		//echo("--> Created file: ".$scaffold_name."/remove.php.\n");

		// ### create show.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/show.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$sqlquery = 'SELECT * FROM '.$scaffold_name.' WHERE '.get_first_pk($fields).'=\'".$_REQUEST[\''.get_first_pk($fields).'\']."\' LIMIT 1';
		$output = str_replace("SQL_QUERY",$sqlquery,$output);
		$d_show = "<table border=\"1\">\n";
		for($i = 0; $i < sizeof($fields); $i++) {
			$field = $fields[$i];
			$d_show .= "<tr>\n";
			$d_show .= "\t<td>".format_field_name($field['name'])."</td>\n";
			$d_show .= "\t".'<td><?= $row["'.$field['name'].'"] ?>'."</td>\n";
			$d_show .= "</tr>\n";
		}
		$d_show .= "</table>\n";
		$output = str_replace("BODY_TEXT_MAIN",$d_show,$output);
		$output = str_replace("PRIMARY_KEY",get_first_pk($fields),$output);
		write_file($output_dir.$scaffold_name."/show.php", $output);
		unset($d_show);
		unset($sqlquery);
		//echo("--> Created file: ".$scaffold_name."/show.php.\n");


		// ### create update.php
		$template = "";
		$output = "";
		$template = file_get_contents("templates/update.tpl");
		$output = str_replace("PHP_HEAD_EXTRA",$php_head_extra,$template);
		$output = str_replace("LIB_PATH",$lib_path,$output);
		$output = str_replace("CONFIG_PATH",$config_path,$output);
		$output = str_replace("HTTP_PROCOL",$http_proto,$output);
		$output = str_replace("APPLICATION_TITLE",$application_title,$output);
		$output = str_replace("CSS_PATH",$css_path,$output);
		$output = str_replace("HTML_HEADER_EXTRA",$html_header_extra,$output);
		$output = str_replace("BODY_HEADER_EXTRA",$body_header_extra,$output);
		$output = str_replace("BODY_FOOTER_EXTRA",$body_footer_extra,$output);
		$output = str_replace("PHP_ORDER_LIMIT",$php_order_limit,$output);
		$d_update = 'UPDATE '.$scaffold_name.' SET ';
		for($i = 0; $i < sizeof($fields); $i++) {
			$field = $fields[$i];
			if($field['is_autoinc'] || $field['name'] == "created_at") {
				// we don't want the PK field to show up
				// the autoinc field is the pk and immutable (at this point)
				// the created_at field is not relevant on updates
			} elseif($field['name'] == "updated_at") {
				$d_update .= $field['name']."='\".time().\"',";
			} else {
				$d_update .= $field['name']."='\".\$_REQUEST['".$field['name']."'].\"',";
			}
		}
		$d_update = substr($d_update,0,-1); // remove last comma (,)
		$d_update .= ' WHERE '.get_first_pk($fields).'=\'".mysql_real_escape_string($_REQUEST[\''.get_first_pk($fields).'\'])."\'';
		$output = str_replace("SQL_QUERY",$d_update,$output);
		write_file($output_dir.$scaffold_name."/update.php", $output);
		unset($d_update);
		//echo("--> Created file: ".$scaffold_name."/update.php.\n");

		// done with this table
		$e .= " done.\n";
	}
	$output_dir_index .= "</ul></body></html>";
	// create a directory index in case the dirindex option is disabled in the webserver config.
	write_file($output_dir."/index.html",$output_dir_index);
	// copy the dba class
	$dbclass = file_get_contents("templates/_class.dba.inc.tpl");
	write_file($output_dir."/_class.dba.inc.php",$dbclass);
	// copy the session file
	$sessionfile = file_get_contents("templates/_static.session.inc.tpl");
	write_file($output_dir."/_static.session.inc.php",$sessionfile);
	// copy the dba config
	$dbconfig = file_get_contents("templates/_conf.dba.inc.tpl");
	$output = str_replace("CONF_APPNAME",$application_title,$dbconfig);
	$output = str_replace("CONF_DB",$db_db,$output);
	$output = str_replace("CONF_HOST",$db_host,$output);
	$output = str_replace("CONF_USER",$db_user,$output);
	$output = str_replace("CONF_PASS",$db_pass,$output);
	write_file($output_dir."/_conf.dba.inc.php",$output);
	$e .= "DONE\n";
} else {
	$e .= "Missing Parameters. Not executing. Please re-check your input.";
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" media="screen" href="style.css" />
<title>Scaffoldr</title>
</head>
<body>
<p><a href="http://developer.gauner.org/scaffoldr/"><img src="logo.png"
	alt="Scaffoldr - PHP Scaffold Generator 2.0" border="0"></a></p>
<table border="0">
	<tr>
		<td>
		<h2>Database Settings</h2>
		<form action="index.php" method="POST">
		<table border="0">
			<tr>
				<td><b>User</b>:</td>
				<td><input type="text" name="db_user" value="<?= $db_user ?>"></td>
			</tr>
			<tr>
				<td><b>Password</b>:</td>
				<td><input type="password" name="db_pass" value="<?= $db_pass ?>"></td>
			</tr>
			<tr>
				<td><b>Database</b>:</td>
				<td><input type="text" name="db_db" value="<?= $db_db ?>"></td>
			</tr>
			<tr>
				<td><b>Host</b>:</td>
				<td><input type="text" name="db_host" value="<?= $db_host ?>"></td>
			</tr>
		</table>
		<input type="submit" name="submit" value="--> Run! <--">
		<p>
		
		
		<h2>Options</h2>
		<table border="0">
			<tr>
				<td><b>lib_path</b>:</td>
				<td><input type="text" name="lib_path" value="<?= $lib_path ?>"></td>
			</tr>
			<tr>
				<td><b>config_path</b>:</td>
				<td><input type="text" name="config_path"
					value="<?= $config_path ?>"></td>
			</tr>
			<tr>
				<td><b>http_protocol</b>:</td>
				<td><input type="text" name="http_protocol"
					value="<?= $http_proto ?>"></td>
			</tr>
			<tr>
				<td><b>application_title</b>:</td>
				<td><input type="text" name="application_title"
					value="<?= $application_title ?>"></td>
			</tr>
			<tr>
				<td><b>css_path</b>:</td>
				<td><input type="text" name="css_path" value="<?= $css_path ?>"></td>
			</tr>
			<tr>
				<td><b>php_order_limit</b>:</td>
				<td><input type="text" name="php_order_limit"
					value="<?= $php_order_limit ?>"></td>
			</tr>
		</table>
		<b>html_header_extra</b>: <br>
		<textarea rows="5" cols="80" name="html_header_extra"><?= $html_header_extra ?></textarea><br>
		<b>body_header_extra</b>: <br>
		<textarea rows="5" cols="80" name="body_header_extra"><?= $body_header_extra ?></textarea><br>
		<b>body_footer_extra</b>: <br>
		<textarea rows="5" cols="80" name="body_footer_extra"><?= $body_footer_extra  ?></textarea><br>
		<b>php_head_extra</b>:<br>
		<textarea rows="5" cols="80" name="php_head_extra"><?= $php_head_extra ?></textarea><br>

		</form>
		</p>
		</td>
		<td width="50%" valign="top">
		<p>
		<h4>Database Settings</h4>
		Enter your MySQL-Database settings here. The Scaffoldr will try
		connect using this credentials and, if successful, create a scaffold
		for the entire database. The resulting html files will be put in the
		subfolder <i><a href="output/">output</a></i>.<br />
		Scaffoldr makes some assumptions about the database layout. It can not handle
		composite primary keys right now and it expects all fields called <i>created_at</i>
		and <i>updated_at</i> to be of type <i>int(16)</i>. It will updated these fields whenever
		a row is updated or created. However, it doesn't require these fields to be there.
		It no longer expects the primary key to be in the first column!
		<h4>Options</h4>
		These are optional options to tweak the output of the Scaffoldr.
		<ul>
			<li><b>lib_path</b>: Specify where the <i>_class.dba.inc.php</i> is
			located relative to the generated files. Note that for every table in
			your database there will be a seperate directory under output so you
			probably need at least a ../ here.</li>
			<li><b>config_path</b>: Specify where the <i>_conf.dba.inc.php</i> is
			located relative to the generated files. The note for lib_path also
			applies here.</li>
			<li><b>http_protocol</b>: Specify which http protocol to use.
			Probably either http or https. Could also be function call to
			determine this on the fly.</li>
			<li><b>application_title</b>: This is put as the first part of the
			html title tag.</li>
			<li><b>css_path</b>: Spefciy where the css file is located.</li>
			<li><b>php_order_limit</b>: The default number of rows to display on
			a single page. Can also be a function call to determine this on the
			fly, e.g. <i>get_config_value("list_limit")</i></li>
			<li><b>html_header_extra</b>: This option is placed in the template.
			See the template for more information.</li>
			<li><b>body_header_extra</b>: This option is placed in the template.
			See the template for more information.</li>
			<li><b>body_footer_extra</b>: This option is placed in the template.
			See the template for more information.</li>
			<li><b>php_head_extra</b>: This option is placed in the template. See
			the template for more information.</li>
		</ul>
		<h4>Templates</h4>
		Have a look at the <i><a href="templates/">templates</a></i> subdir.
		The templates can be changed in any way as long as the markers in
		UPPER cases remain intact.
		</p>
		<h4>Features</h4>
		<ul>
			<li><b>Generation of Scaffolds</b> based on the database schema. No information despite the databse login
			is necessary</li>
			<li><b>Pagination</b></li>
			<li><b>Toggle</b> sorting</li>
			<li><b>Handling of Foreign Keys</b></li>
			<li>Fully <b>Customizable</b></li>
			<li><b>Warning: No handling of composite primary keys!</b></li>
		</ul>
		<p>
		
		
		<h2>Status</h2>
		<textarea rows="20" cols="70">
<?= $e ?>
</textarea>
		</p>
		</td>
	</tr>
</table>
</body>
</html>
